#!/bin/sh

# trivial autoconfigure:
# detect native 64 or 32 target (cross!) bit system

OUTCFG=$1

# tst C source
echo "
int main(void)
{
	TST_TYPE i;

	switch(sizeof(i)) {
		case TST_SIZE:
			break;
		case sizeof(i):
			break;
	}
	return (int)i;
}
" > tst_32-64.c

# Test target system is 64-bit
SYSTEM_IS="int_64"
$CC -DTST_TYPE=int -DTST_SIZE=8 tst_32-64.c > /dev/null 2> /dev/null
if [ $? = 0 ]; then
	SYSTEM_IS="long_64"
	$CC -DTST_TYPE=long -DTST_SIZE=8 tst_32-64.c > /dev/null 2> /dev/null
		if [ $? = 0 ]; then
			SYSTEM_IS="int_32"
			$CC -DTST_TYPE=int -DTST_SIZE=4 tst_32-64.c > /dev/null 2> /dev/null
				if [ $? = 0 ]; then
					SYSTEM_IS="double"
					echo Can not detect 32 or 64 bit system
				fi
		fi
fi

if [ $SYSTEM_IS = "int_32" ]; then
	$CC -DTST_TYPE="long long" -DTST_SIZE=8 tst_32-64.c > /dev/null 2> /dev/null
		if [ $? = 0 ]; then
			SYSTEM_IS="double"
			echo Target compiller unsupport 64-bit \"long long\" type
		else
			SYSTEM_IS="long_long"
		fi
fi

rm -f a.out tst_32-64.c
echo The target type for traffic counter is $SYSTEM_IS

# out config defines

if [ $SYSTEM_IS = "int_64" ]; then
	echo 'typedef int traf_t;' > $OUTCFG
	echo '#define STRTO(s, e, r) strtol(s, e, r)' >> $OUTCFG
fi
if [ $SYSTEM_IS = "long_64" ]; then
	echo "typedef long traf_t;" > $OUTCFG
	echo '#define STRTO(s, e, r) strtol(s, e, r)' >> $OUTCFG
fi
if [ $SYSTEM_IS = "long_long" ]; then
	echo "typedef long long traf_t;" > $OUTCFG
	echo '#define STRTO(s, e, r) strtoll(s, e, r)' >> $OUTCFG
fi
if [ $SYSTEM_IS = "double" ]; then
	echo "typedef double traf_t;" > $OUTCFG
	echo '#define STRTO(s, e, r) strtod(s, e)' >> $OUTCFG
fi
