/*
    tac_acct (stop only)
   0.5
  :   dzo@simtreas.ru
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define SKIP_FIRST   1                  /* weekdays */
#define SKIP_DO_USER 2                  /* date, time, year, ip_router */

struct TAC_DETAL
{
  int data;
  int mes;
  double start;
  double time;
  double out;
};

struct TAC_REPORT
{
  char user[32];
  char mes[13][4];
  double out[13];
  double time[13];
  struct TAC_DETAL *tac_detal;
  int n_tac_detal;
};

struct TAC_REPORT *report;
int nreport;

static char find1[] = "elapsed_time=";
static char find2[] = "bytes_out=";

static int
scip_word (char **buff)
{
  char *ps;
  int ret = 0;

  ps = *buff;

  while (*ps == ' ')
	ps++;
  if (*ps == 0)
	return -1;
  if (strncmp (ps, find1, strlen (find1)) == 0) {
	ps += strlen (find1);
	ret = 1;
  } else if (strncmp (ps, find2, strlen (find2)) == 0) {
	ps += strlen (find2);
	ret = 2;
  } else
	while (*ps) {
	  if (*ps == ' ')
		break;
	  ps++;
	}
  if (ret == 0) {
	if (*ps == 0)
	  return -1;
	*ps = 0;
	ps++;
	if (*ps == 0)
	  return -1;
  }
  while (*ps == ' ')
	ps++;
  *buff = ps;
  return ret;
}

static void
fmt_out_traf (double bd)
{
  int gig;
  int meg;
  int kb;
  int b;
  double bg;

  gig = bd / 1000.0 / 1000.0 / 1000.0;
  bg = ((double) gig) * 1000.0 * 1000.0 * 1000.0;
  meg = ((long) (bd / 1000.0 / 1000.0)) - gig * 1000;
  kb =
	((long) (bd / 1000.0)) - ((long) meg) * 1000 - ((long) gig) * 1000 * 1000;
  b = bd - bg - ((double) kb) * 1000.0 - ((double) meg) * 1000.0 * 1000.0;
  if (gig)
	printf ("%3d %03d %03d.%03d", gig, meg, kb, b);
  else {
	printf ("    ");
	if (meg)
	  printf ("%3d %03d.%03d", meg, kb, b);
	else {
	  printf ("    ");
	  printf ("%3d.%03d", kb, b);
	}
  }
}

static void
fmt_out_time_form (double bd, int *h, int *m, int *s)
{
  int hour;
  int min;
  int sec;
  double bg;

  hour = bd / 60.0 / 60.0;
  bg = ((double) hour) * 60.0 * 60.0;
  min = ((long) (bd / 60.0)) - hour * 60;
  sec = bd - bg - ((double) min) * 60.0;
  if (h == 0)
	printf ("%02d:%02d:%02d", hour, min, sec);
  else {
	*h = hour;
	*m = min;
	*s = sec;
  }
}

static void
fmt_out_time (double bd)
{
  int hour;
  int min;
  int sec;

  fmt_out_time_form (bd, &hour, &min, &sec);
  if (hour)
	printf ("%3d:%02d:%02d", hour, min, sec);
  else {
	printf ("    ");
	if (min)
	  printf ("%2d:%02d", min, sec);
	else {
	  printf ("   ");
	  printf ("%2d", sec);
	}
  }
}


int
main (int argc, char **argv)
{
  FILE *in;
  char buff[512];
  char buff0[512];
  char *ps;
  char *w;
  char mes[4];
  char user[32];
  int i, m;
  double traf, t, stop;
  int step;
  int day;
  int sum_only = 0;
  int sort_time = 0;

  if (argc < 2 || argc > 4) {
	fprintf (stderr, "Usage %s [-s] [-t] tac_in\n", argv[0]);
	return 1;
  }
  while (strcmp (argv[1], "-s") == 0 || strcmp (argv[1], "-t") == 0) {
	if(strcmp (argv[1], "-s") == 0)
		sum_only++;
	else
		sort_time++;
	argv++;
  }
  in = fopen (argv[1], "r");
  if (in == NULL) {
	fprintf (stderr, "Can`t open %s\n", argv[1]);
	return 1;
  }
  while (fgets (buff, 512, in) != NULL) {
	ps = buff;
	step = 0;
	strcpy (buff0, buff);
	while (*ps) {
	  if (*ps == '\t')
		*ps = ' ';
	  ps++;
	}
	ps = buff;
	for (i = 0; i < SKIP_FIRST; i++)
	  if (scip_word (&ps) != 0) {
	  bf:
		fprintf (stderr, "Bad format?\nbuff=%s\nstep=%d skip=%d\n", buff0,
				 step, i);
		return 1;
	  }
	w = ps;
	step++;
	if (scip_word (&ps) != 0)
	  goto bf;
	step++;
	if (w[0] == 0 || w[1] == 0 || w[2] == 0 || w[3] != 0)
	  goto bf;
	strcpy (mes, w);
	step++;
	w = ps;
	step++;
	if (scip_word (&ps) != 0)
	  goto bf;
	step++;
	day = atoi (w);
	if (day <= 0 || day > 31) {
	  fprintf (stderr, "Bad day format?\nbuff=%s\nstep=%d skip=%d\n", buff0,
			   step, i);
	  return 1;
	}
	step++;
	w = ps;
	step++;
	if (scip_word (&ps) != 0)
	  goto bf;
	step++;
	if (w[0] < '0' || w[0] > '2' || w[1] < '0' || w[1] > '9') {
	bf2:
	  fprintf (stderr, "Bad time format?\nbuff=%s\nstep=%d skip=%d\n", buff0,
			   step, i);
	  return 1;
	}
	i = atoi (w);
	if (i < 0 || i > 23)
	  goto bf2;
	stop = i;
	stop *= 3600;
	w += 3;
	if (w[0] < '0' || w[0] > '5' || w[1] < '0' || w[1] > '9')
	  goto bf2;
	i = atoi (w);
	if (i < 0 || i > 59)
	  goto bf2;
	stop += ((unsigned) i) * 60;
	w += 3;
	if (w[0] < '0' || w[0] > '5' || w[1] < '0' || w[1] > '9')
	  goto bf2;
	i = atoi (w);
	if (i < 0 || i > 59)
	  goto bf2;
	stop += i;
	for (i = 0; i < SKIP_DO_USER; i++)
	  if (scip_word (&ps) != 0)
		goto bf;
	w = ps;
	step++;
	if (scip_word (&ps) != 0)
	  goto bf;
	step++;
	if ((ps - w) >= 32) {
	  fprintf (stderr, "User name %s too long, skiped\n", w);
	  continue;
	}
	strcpy (user, w);
	traf = t = -1;
	w = ps;
	for (;;) {
	  step++;
	  switch (scip_word (&ps)) {
	  case -1:
		w = 0;
		break;
	  case 1:
		if (*ps < '0' || *ps > '9')
		  goto bf;
		t = atof (ps);
		while (*ps >= '0' && *ps <= '9')
		  ps++;
		break;
	  case 2:
		if (*ps < '0' || *ps > '9')
		  goto bf;
		traf = atof (ps);
		while (*ps >= '0' && *ps <= '9')
		  ps++;
		break;
	  }
	  if (w == 0) {
		step++;
		if (traf < 0 && t < 0)
		  goto bf;
		if (traf < 0)
		  traf = 0;
		if (t < 0)
		  t = 0;
		break;
	  }
	}
	if (nreport == 0) {
	  i = 0;
	  report = (struct TAC_REPORT *) calloc (1, sizeof (struct TAC_REPORT));
	  if (report == 0) {
	  ou:
		fprintf (stderr, "Out memory\n");
		return 1;
	  }
	  strcpy (report[0].user, user);
	  nreport = 1;
	  goto reput;
	}
	step++;
	for (i = 0; i < nreport; i++)
	  if (strcmp (user, report[i].user) == 0) {
	  reput:
		for (m = 0; m <= 12; m++)
		  if (report[i].mes[m][0] == 0 || strcmp (report[i].mes[m], mes) == 0) {
			if (report[i].mes[m][0] == 0)
			  strcpy (report[i].mes[m], mes);
			report[i].out[m] += traf;
			report[i].time[m] += t;
			report[i].n_tac_detal++;
			if (report[i].tac_detal == 0)
			  report[i].tac_detal =
				(struct TAC_DETAL *) calloc (1, sizeof (struct TAC_DETAL));
			else
			  report[i].tac_detal =
				(struct TAC_DETAL *) realloc (report[i].tac_detal,
											  report[i].n_tac_detal *
											  sizeof (struct TAC_DETAL));
			if (report[i].tac_detal == 0)
			  goto ou;
			while (stop - t < 0) {
			  stop += 24l * 3600;
			  day--;
			  if (day == 0) {
				day = 31;
			  }
			}
			report[i].tac_detal[report[i].n_tac_detal - 1].data = day;
			report[i].tac_detal[report[i].n_tac_detal - 1].start = stop - t;
			report[i].tac_detal[report[i].n_tac_detal - 1].time = t;
			report[i].tac_detal[report[i].n_tac_detal - 1].out = traf;
			break;
		  }
		step++;
		if (m >= 12)
		  goto bf;
		break;
	  }
	if (i == nreport) {
	  nreport++;
	  report = (struct TAC_REPORT *) realloc (report, nreport * sizeof (struct TAC_REPORT));
	  if (report == 0)
		goto ou;
	  memset (&report[i], 0, sizeof (struct TAC_REPORT));
	  strcpy (report[i].user, user);
	  goto reput;
	}
  }
  step = -1;
  if (nreport == 0)
	goto bf;
  m = 0;
  for (i = 0; i < nreport; i++)
	if (strlen (report[i].user) > m)
	  m = strlen (report[i].user);
  sprintf (user, "%%-%ds ", m);
  if (sum_only == 0) {
	for (i = 0; i < nreport; i++) {
	  step = 0;
	  day = -400;
	  printf ("%s:\nMMM DD Start      time            out\n", report[i].user);
	  for (m = 0; m < report[i].n_tac_detal; m++) {
		if (report[i].tac_detal[m].data < day)
		  step++;
		day = report[i].tac_detal[m].data;
		printf ("%3s %2d ", report[i].mes[step], report[i].tac_detal[m].data);
		fmt_out_time_form (report[i].tac_detal[m].start, 0, 0, 0);
		putchar (' ');
		fmt_out_time_form (report[i].tac_detal[m].time, 0, 0, 0);
		putchar (' ');
		fmt_out_traf (report[i].tac_detal[m].out);
		putchar ('\n');
	  }
	}
  }
  sum_only = -1;
  for (i = 0; i < nreport; i++) {
	for (m = 0; m <= 12; m++)
	  if (report[i].mes[m][0]) {
		if (sum_only == -1)
		  sum_only = m;
		else if (sum_only != m) {
		  sum_only = -2;
		  break;
		}
	  }
	if (sum_only == -2)
	  break;
  }
  if (sum_only >= 0) {
	/*    ,  */
	int j;

	m = sum_only;
	for (i = 0; i < nreport; i++)
	  for (j = i + 1; j < nreport; j++) {
	    if (report[i].mes[m][0] && report[j].mes[m][0]) {
		char u[32];
		if(sort_time) {
		   if((report[j].time[m] > report[i].time[m]) ||
				(report[j].time[m] == report[i].time[m] &&
					report[j].out[m] > report[i].out[m])) {
			strcpy(u, report[i].user);
			strcpy(report[i].user, report[j].user);
			strcpy(report[j].user, u);
			t = report[i].out[m];
			report[i].out[m] = report[j].out[m];
			report[j].out[m] = t;
			t = report[i].time[m];
			report[i].time[m] = report[j].time[m];
			report[j].time[m] = t;
		   }
		} else {
		   if((report[j].out[m] > report[i].out[m]) ||
				(report[j].out[m] == report[i].out[m] &&
					report[j].time[m] > report[i].time[m])) {
			strcpy(u, report[i].user);
			strcpy(report[i].user, report[j].user);
			strcpy(report[j].user, u);
			t = report[i].out[m];
			report[i].out[m] = report[j].out[m];
			report[j].out[m] = t;
			t = report[i].time[m];
			report[i].time[m] = report[j].time[m];
			report[j].time[m] = t;
		   }
		}
	    }
	}
	for (i = 0; i < nreport; i++) {
	  printf (user, report[i].user);
	  if (report[i].mes[m][0]) {
		printf ("%3s ", report[i].mes[m]);
		fmt_out_traf (report[i].out[m]);
		putchar (' ');
		putchar (' ');
		fmt_out_time (report[i].time[m]);
	  }
	  putchar ('\n');
	}
  } else {
	for (i = 0; i < nreport; i++) {
	  printf (user, report[i].user);
	  for (m = 0; m <= 12; m++)
		if (report[i].mes[m][0]) {
		  printf ("%3s ", report[i].mes[m]);
		  fmt_out_traf (report[i].out[m]);
		  putchar (' ');
		  putchar (' ');
		  fmt_out_time (report[i].time[m]);
		  putchar (' ');
		  putchar (' ');
		  putchar (' ');
		}
	  putchar ('\n');
	}
  }
  return 0;
}
